###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Erik Enge <erik@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.6 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import note_sort
import base_item

manage_add_notes_form = HTMLFile('notes_add', globals())


def manage_add_notes(self, id, title, description, REQUEST=None, RESPONSE=None):
    "Add an instance of the Notes class"

    self._setObject(id, notes(id, title, description))

    if RESPONSE is not None:

        RESPONSE.redirect(self.absolute_url())


class notes(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	product_name = 'Notes'

	meta_type = 'Notes'
	icon = 'misc_/Notes/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		{'id':'description', 'type':'text'},
		)

	meta_types = (
		{'name':'NoteSort', 'action':'manage_add_note_sort_form'},
		)

	manage_add_note_sort_form = note_sort.manage_add_note_sort_form
	manage_add_note_sort = note_sort.manage_add_note_sort


	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add NoteSort',
		 ('manage_add_note_sort', 'manage_add_note_sort_form')),
		('View Notes',
		 ('',)),
		)

	index_html = HTMLFile('notes_index', globals())
	display = HTMLFile('notes_display', globals())

	def get_note_categories(self):
		"""Returns a list of note categories."""

		return self.objectValues('NoteSort')

	def get_unique_id(self):
		"""Returns a unique identifier."""

		try:

			return self.getParentNode().get_id()

		except AttributeError:

			self.counter = self.counter + 1

			return str(self.counter)


	def __init__(self, id, title='', description=''):
		"Initialize the class instance"

		self.id = id
		self.title = title
		self.description = description

		self.counter = 0


		OFS.DTMLMethod.addDTMLMethod(self, 'standard_html_header',
									 'standard_html_header',
									 open('%s/Products/%s/standard_html_header.dtml' % \
										  (SOFTWARE_HOME, self.product_name)).read())
										  
		OFS.DTMLMethod.addDTMLMethod(self, 'standard_html_footer',
									 'standard_html_footer',
									 open('%s/Products/%s/standard_html_footer.dtml' % \
										  (SOFTWARE_HOME, self.product_name)).read())

		OFS.DTMLMethod.addDTMLMethod(self, 'standard_css', 'standard_css',
									 open('%s/Products/%s/standard_css.dtml' % \
										  (SOFTWARE_HOME, self.product_name)).read())

default__class_init__(notes)

